SystemOrganization addCategory: #ConfigurationOfHOWebStack!

Object subclass: #ConfigurationOfHOWebStack
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfHOWebStack'!

!ConfigurationOfHOWebStack commentStamp: '<historical>' prior: 0!
A ConfigurationOfHOWebStack class is xxxxxxxxx.

Instance Variables
!

!ConfigurationOfHOWebStack class methodsFor: 'development support' stamp: 'PhilippeBack 6/21/2013 10:22'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfHOWebStack class methodsFor: 'private' stamp: 'PhilippeBack 6/21/2013 10:22'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfHOWebStack class methodsFor: 'private' stamp: 'PhilippeBack 6/21/2013 10:22'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfHOWebStack class methodsFor: 'private' stamp: 'PhilippeBack 6/21/2013 10:22'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfHOWebStack class methodsFor: 'metacello tool support' stamp: 'PhilippeBack 6/21/2013 10:22'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfHOWebStack class methodsFor: 'loading' stamp: 'PhilippeBack 6/21/2013 10:22'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfHOWebStack class methodsFor: 'loading' stamp: 'PhilippeBack 6/21/2013 10:22'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfHOWebStack class methodsFor: 'loading' stamp: 'PhilippeBack 6/21/2013 10:22'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfHOWebStack class methodsFor: 'accessing' stamp: 'PhilippeBack 6/21/2013 10:22'!
project

	^self new project! !

!ConfigurationOfHOWebStack class methodsFor: 'development support' stamp: 'PhilippeBack 6/21/2013 10:22'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfHOWebStack methodsFor: 'baselines' stamp: 'PhilippeBack 6/21/2013 13:00'!
baseline01: spec 
        <version: '0.1-baseline'>
        
        spec for: #common do: [
                spec blessing: #baseline.
		    spec repository: 'http://www.smalltalkhub.com/mc/philippeback/HOWebStack/main'.    
		
   	          spec repository: 'http://www.smalltalkhub.com/mc/PharoExtras/FileSystemLegacy/main'.
		    spec
			      package: 'FileSystem-Legacy'.
		
		    spec project: 'Seaside30' with: [ 
				spec
					className: 'ConfigurationOfSeaside30';
					"loads: #('Core');"
					versionString: #stable;
					file: 'ConfigurationOfSeaside30';
					repository: 'http://ss3.gemstone.com/ss/MetaRepoForPharo20' ].		
						
		   spec project: 'SeasideRest' with: [ 
				spec
					className: 'ConfigurationOfSeasideRest';
					"loads: #('Core');"
					versionString: #stable;
					file: 'ConfigurationOfSeasideRest';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].		
		
		    spec project: 'TwitterBootstrap' with: [ 
				spec
					className: 'ConfigurationOfTwitterBootstrap';
					"loads: #('Core');"
					versionString: #stable;
					file: 'ConfigurationOfTwitterBootstrap';
					repository: 'http://ss3.gemstone.com/ss/TwitterBootstrap' ].		
		
		    spec project: 'Oak' with: [ 
				spec
					className: 'ConfigurationOfOak';
					"loads: #('Core');"
					versionString: #development;
					file: 'ConfigurationOfOak';
					repository: 'http://www.smalltalkhub.com/mc/NicolasPetton/Oak/main' ].		
						
		    spec project: 'Pomodoro' with: [ 
				spec
					className: 'ConfigurationOfPomodoro';
					"loads: #('Pomodoro');"
					versionString: #stable;
					file: 'ConfigurationOfPomodoro';
					repository: 'http://smalltalkhub.com/mc/TorstenBergmann/Pomodoro/main' ].

		    spec repository: 'http://www.smalltalkhub.com/mc/philippeback/HOSeaside/main'.
	          spec 
                        package: 'HighOctane-Seaside';
				package: 'Settings-HighOctane-Seaside'.

		    spec repository: 'http://www.smalltalkhub.com/mc/philippeback/MemoryMonitor/main'.
	          spec 
                        package: 'MemoryMonitor'.


	].! !

!ConfigurationOfHOWebStack methodsFor: 'baselines' stamp: 'PhilippeBack 9/24/2013 20:18'!
baseline02: spec 
        <version: '0.2-baseline'>
        
        spec for: #common do: [
                spec blessing: #baseline.
		    spec repository: 'http://www.smalltalkhub.com/mc/philippeback/HOWebStack/main'.    
		
   	          spec repository: 'http://www.smalltalkhub.com/mc/PharoExtras/FileSystemLegacy/main'.
		    spec
			      package: 'FileSystem-Legacy'.
		
		    spec project: 'Seaside3' with: [ 
				spec
					className: 'ConfigurationOfSeaside3';
					"loads: #('Core');"
					versionString: #stable;
					file: 'ConfigurationOfSeaside3';
					repository: 'http://www.smalltalkhub.com/mc/Seaside/MetacelloConfigurations/main' ].		
						
						
		    spec project: 'SeasideRest' with: [ 
				spec
					className: 'ConfigurationOfSeasideRest';
					"loads: #('Core');"
					versionString: #stable;
					file: 'ConfigurationOfSeasideRest';
					repository: 'http://www.smalltalkhub.com/mc/Seaside/MetacelloConfigurations/main' ].		
						
		    spec project: 'Pomodoro' with: [ 
				spec
					className: 'ConfigurationOfPomodoro';
					"loads: #('Pomodoro');"
					versionString: #stable;
					file: 'ConfigurationOfPomodoro';
					repository: 'http://smalltalkhub.com/mc/TorstenBergmann/Pomodoro/main' ].

		    spec repository: 'http://www.smalltalkhub.com/mc/philippeback/HOSeaside/main'.
	          spec 
                        package: 'HighOctane-Seaside';
				package: 'Settings-HighOctane-Seaside'.

		    spec repository: 'http://www.smalltalkhub.com/mc/philippeback/MemoryMonitor/main'.
	          spec 
                        package: 'MemoryMonitor'.


	].! !

!ConfigurationOfHOWebStack methodsFor: 'accessing' stamp: 'PhilippeBack 6/21/2013 10:22'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfHOWebStack methodsFor: 'symbolic versions' stamp: 'PhilippeBack 9/24/2013 19:45'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #common version: '0.2'.

! !

!ConfigurationOfHOWebStack methodsFor: 'accessing' stamp: 'PhilippeBack 6/21/2013 10:22'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfHOWebStack methodsFor: 'versions' stamp: 'PhilippeBack 6/21/2013 11:54'!
version01: spec 
        <version: '0.1' imports: #('0.1-baseline') >
       ! !

!ConfigurationOfHOWebStack methodsFor: 'versions' stamp: 'PhilippeBack 9/24/2013 19:45'!
version02: spec 
        <version: '0.2' imports: #('0.2-baseline') >
       ! !
